<?php

declare(strict_types=1);

namespace mirzaev\beejee\controllers;

use mirzaev\beejee\controllers\controller;

/**
 * Контроллер аутентификации
 *
 * @package mirzaev\beejee\controllers
 * @author Arsen Mirzaev Tatyano-Muradovich <red@hood.su>
 */
final class authController extends controller
{
    /**
     * Аутентификация
     *
     * @param array $params
     *
     * @return array|null
     */
    public function auth(array $params = null): ?array
    {
        $login = $params['login'] ?? $_COOKIE['login'];
        $password = $params['password'] ?? $_COOKIE['password'];

        if (isset($login, $password)) {
            return $this->model->auth($login, $password);
        }

        return null;
    }

    /**
     * Деаутентификация
     *
     * @param array $params
     *
     * @return void
     */
    public function deauth(array $params = null): void
    {
        session_start();

        // Выборочное удаление параметров сессии
        unset($_SESSION['id']);
        unset($_SESSION['admin']);

        // session_unset();
        // session_destroy();
    }

    /**
     * Сгенерировать представление HTML-сайдбара
     *
     * @param array $params
     *
     * @return string|null
     */
    public function genSidebarPanel(array $params = null): ?string
    {
        // Инициализация пользователя
        $user = empty($this->auth()) ? false : true;

        session_start();
        // Инициализация админ-прав
        $admin = $_SESSION['admin'];

        // Генерация представления
        return $this->view->render(DIRECTORY_SEPARATOR . 'auth' . DIRECTORY_SEPARATOR . 'auth_sidebar.html', ['user' => $user, 'admin' => $admin]);
    }
}
